// xRawImgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "xRawImg.h"
#include "xRawImgDlg.h"
#include "glob.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
Rw head;
RgB *data;
long Size;
FILE *file;
CString nm;
char nam[128];
CString titl;
BOOL DRAW=FALSE;
CDC *dc;
CDC memDC;



int LoadRaw(char *name)
{
	int i=0;
	file=fopen(name,"rb");
	if(file==0)
	{
		return 1;
	}
	fseek(file,0,2);
	Size=ftell(file);
	fseek(file,0,0);
	RgBA rgba;
	fread(&head,sizeof(Rw),1,file);
	if(head.id[0]!=0x69&&head.id[1]!=0x70&&head.id[2]!=0x52)
	{
		return 2;
	}
	data=new RgB[head.X*head.Y*3];
	if(!data)
		return 3;
	i=head.X*head.Y-1;

	while(i!=0)
	{
		fread(&rgba,4,1,file);
		data[i].r=rgba.r;
		data[i].g=rgba.g;
		data[i].b=rgba.b;
		i--;
	}
	return 0;
}

int SaveTGA(char *name)
{
	FILE *out;
	out=fopen(name,"wb");
	if(out==0)
		return 1;
	TGA tga;
	//Fill TGA//
	tga.ID[0]=0;
	tga.ID[1]=0;
	tga.ID[2]=0x02;
	tga.ID[3]=0;
	tga.ID[4]=0;
	tga.ID[5]=0;
	tga.ID[6]=0;
	tga.ID[7]=0x18;
	tga.ID[8]=0;
	tga.ID[9]=0;
	tga.ID[10]=0;
	tga.ID[11]=0;
	tga.tgaX=head.X;
	tga.tgaY=head.Y;
	tga.sNomber2=0x18;
	tga.sNomber3=0x20;
	//===========//
	fwrite(&tga,sizeof(TGA),1,out);
	fwrite(data,head.X*head.Y*3,1,out);
	fclose(out);
	return 0;
}

void Clear(CDC *pDC)
{
	pDC->FillSolidRect(0,0,256,256,RGB(0,0,0));
}

void DrawMem(CDC *DC,int X,int Y)
{
	CBitmap d;
	int i=0;
	int x=0,y=0;
	d.CreateCompatibleBitmap(DC,X,Y);
	memDC.CreateCompatibleDC(DC);
	memDC.SelectObject(d);
	while(i!=X*Y)
	{
		if(x==X)
		{
			x=0;
			y++;
		}
		memDC.SetPixel(x,y,RGB(data[i].b,data[i].g,data[i].r));
		i++;
		x++;
	}
}

void DrawIMG(CDC *DC,int X,int Y)
{
        DC->BitBlt(0,0,X,Y,&(memDC),0,0,SRCCOPY);
};

void Dell_memDC()
{
	memDC.DeleteDC();
};


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXRawImgDlg dialog

CXRawImgDlg::CXRawImgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXRawImgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXRawImgDlg)
	name = _T("");
	X = 0;
	Y = 0;
	Siz = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CXRawImgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXRawImgDlg)
	DDX_Text(pDX, IDC_name, name);
	DDX_Text(pDX, IDC_X, X);
	DDX_Text(pDX, IDC_Y, Y);
	DDX_Text(pDX, IDC_SIZ, Siz);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXRawImgDlg, CDialog)
	//{{AFX_MSG_MAP(CXRawImgDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXRawImgDlg message handlers

BOOL CXRawImgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	dc=GetDC();
	Clear(dc);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CXRawImgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CXRawImgDlg::OnPaint() 
{
	if(DRAW)
	{
		Clear(dc);
		DrawIMG(dc,X,Y);
		//MessageBox("DRAW","DRAW");
	}
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CXRawImgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CXRawImgDlg::OnOpen() 
{
	DRAW=FALSE;
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE,NULL,NULL,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,"Image files (*.raw)|*.raw||");
	if(dlg.DoModal()==IDOK)
	{
		nm=dlg.GetPathName();
		name=dlg.GetFileName();
		titl=dlg.GetFileTitle();
		strcpy(nam,nm);
		if(LoadRaw(nam)!=0)
		{
			MessageBox("Can`t open RAW!","ERROR!",NULL);
			DRAW=FALSE;
		}
		else
		{
			X=head.X;
			Y=head.Y;
			Siz=Size;
			
			
			UpdateData(false);
			UpdateWindow();

			Clear(dc);
			Dell_memDC();
			DrawMem(dc,X,Y);
			DrawIMG(dc,X,Y);
			DRAW=TRUE;
		}
	}
	else
	{
		DRAW=TRUE;
	}
	
}

void CXRawImgDlg::OnSave() 
{
	if(DRAW)
	{
		titl=titl+".tga";
		
		// TODO: Add your control notification handler code here
		CFileDialog d(FALSE,NULL,titl,OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,"Image files (*.*)|*.*||");
		if(d.DoModal()==IDOK)
		{
			titl=d.GetPathName();
			strcpy(nam,titl);
			if(SaveTGA(nam)!=0)
			{
				MessageBox("Can`t Save TGA file!","ERROR!",0);
			}
		}
	}
};